stages:
  - build
  - publish
  - downstream
variables:
  DOCKER_HOST: tcp://docker:2376
  DOCKER_TLS_CERTDIR: "/certs"
  DOCKER_CLI_EXPERIMENTAL: "enabled"
  PLATFORM: linux/amd64,linux/arm64,linux/arm/v6,linux/arm/v7
  DOCKER_IMAGE_ALPINE_NAME: $CI_REGISTRY/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME/proxima-alpine
  DOCKER_IMAGE_AMD64_ALPINE_NAME: $CI_REGISTRY/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME/amd64-proxima-alpine
  DOCKER_IMAGE_I386_ALPINE_NAME: $CI_REGISTRY/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME/i386-proxima-alpine
  DOCKER_IMAGE_ARM32V6_ALPINE_NAME: $CI_REGISTRY/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME/arm32v6-proxima-alpine
  DOCKER_IMAGE_ARM64V8_ALPINE_NAME: $CI_REGISTRY/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME/arm64v8-proxima-alpine
  DOCKER_IMAGE_UBUNTU_NAME: $CI_REGISTRY/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME/proxima-ubuntu-base

# Ubuntu Images
proxima-ubuntu-base:
  stage: build
  tags:
    - docker
  image: docker:19.03.8
  services:
    - docker:19.03.8-dind
  before_script:
    - cd $CI_PROJECT_DIR/ubuntu
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker pull $DOCKER_IMAGE_UBUNTU_NAME:latest || true
  script:
    - docker build --cache-from $DOCKER_IMAGE_UBUNTU_NAME:latest --tag $DOCKER_IMAGE_UBUNTU_NAME:latest --tag $DOCKER_IMAGE_UBUNTU_NAME:$CI_COMMIT_SHA .
    - docker push $DOCKER_IMAGE_UBUNTU_NAME:latest
    - docker push $DOCKER_IMAGE_UBUNTU_NAME:$CI_COMMIT_SHA
  after_script:
    - cd $CI_PROJECT_DIR

# Alpine Images
proxima-alpine:amd64:
  stage: build
  tags:
    - docker
  image: docker:stable
  services:
    - docker:stable-dind
  before_script:
    - cd $CI_PROJECT_DIR/alpine
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker pull $DOCKER_IMAGE_AMD64_ALPINE_NAME:latest || true
  script:
    - docker build -f ./Dockerfile --cache-from $DOCKER_IMAGE_AMD64_ALPINE_NAME:latest --build-arg BASE_ARCH=amd64 --tag $DOCKER_IMAGE_AMD64_ALPINE_NAME:latest --tag $DOCKER_IMAGE_AMD64_ALPINE_NAME:$CI_COMMIT_SHA .
    - docker push $DOCKER_IMAGE_AMD64_ALPINE_NAME:latest
    - docker push $DOCKER_IMAGE_AMD64_ALPINE_NAME:$CI_COMMIT_SHA
  after_script:
    - cd $CI_PROJECT_DIR

proxima-alpine:i386:
  stage: build
  tags:
    - docker
  image: docker:stable
  services:
    - docker:stable-dind
  before_script:
    - cd $CI_PROJECT_DIR/alpine
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker pull $DOCKER_IMAGE_I386_ALPINE_NAME:latest || true
  script:
    - docker build -f ./Dockerfile --cache-from $DOCKER_IMAGE_I386_ALPINE_NAME:latest --build-arg BASE_ARCH=i386 --tag $DOCKER_IMAGE_I386_ALPINE_NAME:latest --tag $DOCKER_IMAGE_I386_ALPINE_NAME:$CI_COMMIT_SHA .
    - docker push $DOCKER_IMAGE_I386_ALPINE_NAME:latest
    - docker push $DOCKER_IMAGE_I386_ALPINE_NAME:$CI_COMMIT_SHA
  after_script:
    - cd $CI_PROJECT_DIR


proxima-alpine:arm32v6:
  stage: build
  tags:
    - docker
  image: docker:stable
  services:
    - docker:stable-dind
  before_script:
    - cd $CI_PROJECT_DIR/alpine
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker run --rm --privileged multiarch/qemu-user-static --reset -p yes
    - docker pull $DOCKER_IMAGE_ARM32V6_ALPINE_NAME:latest || true
  script:
    - docker build -f ./Dockerfile --cache-from $DOCKER_IMAGE_ARM32V6_ALPINE_NAME:latest --build-arg BASE_ARCH=arm32v6 --tag $DOCKER_IMAGE_ARM32V6_ALPINE_NAME:latest --tag $DOCKER_IMAGE_ARM32V6_ALPINE_NAME:$CI_COMMIT_SHA .
    - docker push $DOCKER_IMAGE_ARM32V6_ALPINE_NAME:latest
    - docker push $DOCKER_IMAGE_ARM32V6_ALPINE_NAME:$CI_COMMIT_SHA
  after_script:
    - cd $CI_PROJECT_DIR

proxima-alpine:arm64v8:
  stage: build
  tags:
    - docker
  image: docker:stable
  services:
    - docker:stable-dind
  before_script:
    - cd $CI_PROJECT_DIR/alpine
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker run --rm --privileged multiarch/qemu-user-static --reset -p yes
    - docker pull $DOCKER_IMAGE_ARM64V8_ALPINE_NAME:latest || true
  script:
    - docker build -f ./Dockerfile --cache-from $DOCKER_IMAGE_ARM64V8_ALPINE_NAME:latest --build-arg BASE_ARCH=arm64v8 --tag $DOCKER_IMAGE_ARM64V8_ALPINE_NAME:latest --tag $DOCKER_IMAGE_ARM64V8_ALPINE_NAME:$CI_COMMIT_SHA .
    - docker push $DOCKER_IMAGE_ARM64V8_ALPINE_NAME:latest
    - docker push $DOCKER_IMAGE_ARM64V8_ALPINE_NAME:$CI_COMMIT_SHA
  after_script:
    - cd $CI_PROJECT_DIR
    
proxima-alpine:
  stage: publish
  needs: ["proxima-alpine:amd64", "proxima-alpine:i386", "proxima-alpine:arm32v6", "proxima-alpine:arm64v8"]
  tags:
    - docker
  image: docker:stable
  services:
    - docker:stable-dind
  before_script:
    - cd $CI_PROJECT_DIR/alpine
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - docker manifest create $DOCKER_IMAGE_ALPINE_NAME:latest $DOCKER_IMAGE_AMD64_ALPINE_NAME:latest $DOCKER_IMAGE_I386_ALPINE_NAME:latest $DOCKER_IMAGE_ARM32V6_ALPINE_NAME:latest $DOCKER_IMAGE_ARM64V8_ALPINE_NAME:latest
    - docker manifest push --purge $DOCKER_IMAGE_ALPINE_NAME:latest

    - docker manifest create $DOCKER_IMAGE_ALPINE_NAME:$CI_COMMIT_SHA $DOCKER_IMAGE_AMD64_ALPINE_NAME:$CI_COMMIT_SHA $DOCKER_IMAGE_I386_ALPINE_NAME:$CI_COMMIT_SHA $DOCKER_IMAGE_ARM32V6_ALPINE_NAME:$CI_COMMIT_SHA $DOCKER_IMAGE_ARM64V8_ALPINE_NAME:$CI_COMMIT_SHA
    - docker manifest push --purge $DOCKER_IMAGE_ALPINE_NAME:$CI_COMMIT_SHA
  after_script:
    - cd $CI_PROJECT_DIR

network-vpn:
  stage: downstream
  needs: ["proxima-alpine"]
  image: curlimages/curl:latest
  script:
    - curl -X POST -F token=$NETWORK_VPN_TOKEN -F ref=master https://gitlab.com/api/v4/projects/23920862/trigger/pipeline
